@import '~assets/scss/variables.scss';

@function rem($num) {
  $strip-unit: $num / ($num * 0 + 1);
  @return $strip-unit / 16 * 1rem;
}

@mixin h1 {
  font-size: rem(50);
  font-weight: 700;
  line-height: rem(60);
  color: $black;
}

@mixin h2 {
  font-size: rem(44);
  font-weight: 700;
  line-height: rem(54);
  color: $black;
}

@mixin h3 {
  font-size: rem(32);
  font-weight: 700;
  line-height: rem(44);
  color: $black;
}

@mixin h4 {
  font-size: rem(24);
  font-weight: 700;
  line-height: rem(28);
  color: $black;
}

@mixin h5 {
  font-size: rem(18);
  font-weight: 700;
  line-height: rem(24);
  color: $black;
}

@mixin p1 {
  font-size: rem(16);
  font-weight: 600;
  line-height: rem(24);
  color: $black;
}

@mixin p2 {
  font-size: rem(14);
  font-weight: 400;
  line-height: rem(24);
  color: rgba($black, .6);
}

@mixin p3 {
  font-size: rem(12);
  font-weight: 400;
  line-height: rem(20);
  color: rgba($black, .5);
}

@mixin bold-black-link {
  font-weight: 600;
  font-size: rem(14);
  line-height: rem(22);
  color: $black;
}

@mixin main-link {
  &:hover, &:active {
    color: $green;
  }
}

@mixin btn-reset {
  border: none;
  background: none;
  padding: 0;
}

@mixin green-btn {
  background: $gradient-green;
  border: rem(1) solid rgba($white, 0.3);
  box-shadow: rem(4) rem(4) rem(14) rgba(84, 211, 194, 0.24),
    rem(-4) rem(-4) rem(14) $white,
    rem(-4) rem(-4) rem(20) $white,
    0 rem(4) rem(14) rgba(84, 211, 194, 0.06),
    rem(-4) rem(-4) rem(4) $white,
    rem(4) rem(4) rem(30) rgba(84, 211, 194, 0.3),
    rem(4) rem(4) rem(14) $white,
    inset rem(16) rem(16) rem(30) rgba($white, 0.2);

  transition: all .35s;
}

@mixin gray-btn {
  background: $light-gray;
  border: rem(1) solid rgba($white, 0.4);
  box-shadow: rem(4) rem(4) rem(14) rgba(213, 220, 228, 0.6),
    rem(-4) rem(-4) rem(14) $white,
    rem(-4) rem(-4) rem(20) $white,
    rem(4) rem(4) rem(14) #D5DCE4,
    rem(-4) rem(-4) rem(10) $white,
    rem(4) rem(4) rem(4) rgba(213, 220, 228, 0.14);

  transition: all .35s;
}

@mixin gray-btn-active {
  background: $gray;
  border: rem(1) solid rgba($white, 0.6);
  box-shadow: inset rem(-4) rem(-4) rem(10) $white,
    inset rem(4) rem(4) rem(10) #D5DCE4,
    inset rem(-4) rem(-4) rem(6) rgba($white, 0.25);
}

@mixin gray-shadow {
  box-shadow: rem(4) rem(4) rem(14) rgba(213, 220, 228, 0.6),
    rem(-4) rem(-4) rem(14) $white,
    rem(-4) rem(-4) rem(20) $white,
    rem(4) rem(4) rem(14) #D5DCE4,
    rem(-4) rem(-4) rem(10) $white,
    rem(4) rem(4) rem(4) rgba(213, 220, 228, 0.14);
}

@mixin red-shadow {
  box-shadow: rem(4) rem(4) rem(14) rgba($red, 0.25),
    rem(-4) rem(-4) rem(14) $white,
    rem(-4) rem(-4) rem(20) $white,
    rem(4) rem(4) rem(14) #D5DCE4,
    rem(-4) rem(-4) rem(10) $white,
    rem(4) rem(4) rem(4) rgba($red, 0.1);
}

@mixin green-shadow {
  box-shadow: rem(4) rem(4) rem(14) rgba(84, 211, 194, 0.24),
    rem(-4) rem(-4) rem(14) $white,
    rem(-4) rem(-4) rem(20) $white,
    0 rem(4) rem(14) rgba(84, 211, 194, 0.06),
    rem(-4) rem(-4) rem(4) $white,
    rem(4) rem(4) rem(30) rgba(84, 211, 194, 0.3),
    rem(4) rem(4) rem(14) $white,
    inset rem(16) rem(16) rem(30) rgba($white, 0.2);
}

@mixin base-input {
  @include bold-black-link;

  border: rem(2) solid #DCE2EF;
  border-radius: rem(4);
  background: transparent;
  transition: border-color .25s;

  &.success {
    border-color: rgba($green, .5);

    &.focused, &:focus {
      border-color: $green;
    }
  }

  &.error {
    border-color: $red;
  }

  &::placeholder {
    @include bold-black-link;

    font-family: $montserrat;
    color: rgba($black, .4);
  }

  &:invalid, & input {
    box-shadow: none;
  }

  &:focus::placeholder {
    opacity: 0;
  }
}

@mixin room-card-tag {
  display: inline-flex;
  align-items: center;
  height: rem(30);
  padding: 0 rem(10);

  font-weight: 600;
  font-size: rem(12);
  line-height: rem(16);
  color: $black;

  background: $white;
  border-radius: rem(4);
}

@mixin breadcrumbs {
  display: flex;
  flex-flow: wrap;

  margin: 0 rem(-10);

  span, a {
    @include p2;

    margin: 0 rem(10);

    &:not(:first-child) {
      position: relative;

      &::before {
        content: '';

        position: absolute;
        left: rem(-12);
        top: 50%;
        transform: translateY(-50%);

        width: rem(4);
        height: rem(4);

        border-radius: 50%;
        background: rgba($black, .2);
      }
    }
  }

  a:hover {
    color: $green;
  }
}

@mixin list {
  &::before {
    @include p2;

    content:attr(aria-label);
    display: block;
  }
}

@mixin numeric-list {
  &::before {
    margin-bottom: rem(20);
  }

  counter-reset: listIndex;

  li {
    & + li {
      margin-top: rem(20);
    }

    display: flex;
    align-items: baseline;

    &::before {
      @include gray-btn;
      @include bold-black-link;

      counter-increment: listIndex;
      content: counter(listIndex);

      display: inline-flex;
      align-items: center;
      justify-content: center;

      flex: 0 0 rem(30);
      width: rem(30);
      height: rem(30);
      margin-right: rem(24);

      color: rgba($black, .3);
      border-radius: 50%;
    }

    p {
      @include p2;

      margin: 0;
    }

  }
}

@mixin marked-list {
  &::before {
    margin-bottom: rem(16);
  }

  li {
    & + li {
      margin-top: rem(16);
    }

    display: flex;
    align-items: baseline;

    &::before {
      content: '';

      flex: 0 0 rem(8);
      width: rem(8);
      height: rem(8);
      margin-right: rem(16);

      background: $green;
      border-radius: 50%;
    }

    p {
      @include p2;

      margin: 0;
    }
  }
}

@mixin blockquote {
  padding: rem(40) rem(54);

  background: $gradient-green;
  border-radius: rem(8);

  @media (max-width: $mobile-width) {
    padding: rem(28) rem(32);
  }

  p {
    @include p1;
    color: $white;

    margin-top: 0;
    margin-bottom: rem(12);
  }

  cite {
    @include p1;
    color: rgba($white, .6);

    strong {
      font-weight: inherit;
      color: $white;
    }
  }

}

@mixin table {
  @media (max-width: $mobile-width) {
    overflow-y: scroll;
    width: 100%;

    .ps__rail-x:not(:hover) {
      opacity: .5;
    }
  }

  .table-title {
    @include h5;

    position: sticky;
    left: 0;

    text-align: center;
    margin-bottom: rem(16);
  }

  table {
    width: 100%;

    @media (max-width: $mobile-width) {
      min-width: 44rem;
    }

    td {
      @include bold-black-link;

      padding: rem(18) rem(12);

      &:first-child {
        padding-left: 0;
      }

      &:last-child {
        padding-right: 0;
      }
    }

    tbody {
      td {
        font-weight: 400;
        border-bottom: rem(2) solid #DCE2EF;
      }
    }

    thead {
      td {
        padding: rem(16) rem(12);
        border-bottom: rem(2) solid $green;
        color: rgba($black, .6);
      }
    }
  }
}

@mixin checkbox {
  input[type="checkbox"] {
    display: none;
  }

  display: flex;
  cursor: pointer;

  &.error {
    .checkbox__field {
      border: rem(1) solid rgba($red, 0.6);
      box-shadow: inset rem(-4) rem(-4) rem(2) rgba($red, 0.1),
      inset rem(4) rem(4) rem(4) #D5DCE4,
      inset rem(-4) rem(-4) rem(4) rgba($red, 0.1);
    }
  }

  &__field {
    flex: 0 0 rem(24);
    width: rem(24);
    height: rem(24);
    margin-right: rem(10);

    background: $gray;
    border: rem(1) solid rgba($white, 0.6);
    box-shadow: inset rem(-4) rem(-4) rem(2) rgba($white, 0.6),
    inset rem(4) rem(4) rem(4) #D5DCE4,
    inset rem(-4) rem(-4) rem(4) rgba($white, 0.25);
    border-radius: rem(8);
  }

  &__icon {
    display: none;
  }

  input:checked ~ .checkbox__field {
    @include green-btn;

    display: flex;
    align-items: center;
    justify-content: center;

    .checkbox__icon {
      display: block;
    }
  }

  &__label {
    @include p2;
    color: $black;
  }
}

@mixin to-top-arrow {
  @include gray-btn;

  &:active {
    @include gray-btn-active;
  }

  flex: 0 0 rem(40);
  width: rem(40);
  height: rem(40);

  display: flex;
  align-items: center;
  justify-content: center;

  border-radius: 50%;

  svg {
    width: rem(16);
    height: rem(16);

    transform: rotate(180deg);

    path {
      stroke-width: 1px;
    }
  }
}
